package com.ruoyi.mall.mapper;

import java.util.List;

import com.ruoyi.mall.domain.MallGoodsGoods;
import com.ruoyi.mall.domain.MallGoodsProduct;
import com.ruoyi.mall.domain.vo.GoodsProductVO;
import org.apache.ibatis.annotations.Param;

/**
 * 商品 产品Mapper接口
 *
 * @author chang
 * @date 2021-11-25
 */
public interface MallGoodsProductMapper
{
    /**
     * 查询商品 产品
     *
     * @param id 商品 产品主键
     * @return 商品 产品
     */
    public MallGoodsProduct selectMallGoodsProductById(Long id);

    /**
     * 查询商品 产品列表
     *
     * @param mallGoodsProduct 商品 产品
     * @return 商品 产品集合
     */
    public List<MallGoodsProduct> selectMallGoodsProductList(MallGoodsProduct mallGoodsProduct);

    /**
     * 新增商品 产品
     *
     * @param mallGoodsProduct 商品 产品
     * @return 结果
     */
    public int insertMallGoodsProduct(MallGoodsProduct mallGoodsProduct);

    /**
     * 修改商品 产品
     *
     * @param mallGoodsProduct 商品 产品
     * @return 结果
     */
    public int updateMallGoodsProduct(MallGoodsProduct mallGoodsProduct);

    /**
     * 删除商品 产品
     *
     * @param id 商品 产品主键
     * @return 结果
     */
    public int deleteMallGoodsProductById(Long id);
    public int removeByGoodsId(Long goodsId);

    /**
     * 批量删除商品 产品
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteMallGoodsProductByIds(Long[] ids);

    /*
     * 根据商品id、规格id 查价格、库存等
     * */
    public List<GoodsProductVO>  selectMallGoodProByParams(MallGoodsProduct pro);

    public List<MallGoodsProduct> selectMallGoodsProductByGoodsId(Long id);

    /*
    * 商品id查所有规格
    * */
    public List<GoodsProductVO> selectMallGoodsProductByGoodsIdVO(Long aLong);

    //加库存
    public void updateMallGoodsProductByParamsRefund(@Param("productId") Long productId, @Param("total") Integer total);
    //减库存
    public void updateMallGoodsProductByParams(@Param("productId") Long productId, @Param("total") Integer total);

    /**
     * 批量新增商品规格
     *
     * @param list 商品规格列表
     * @return 商品 产品集合
     */
    public int bathInsertListMallGoodsProduct(List<MallGoodsProduct> list);

    /**
     * 批量修改商品规格
     *
     * @param list 商品规格列表
     * @return 商品 产品集合
     */
    public int bathUpdateListMallGoodsProduct(List<MallGoodsProduct> list);

    /**
     * 批量删除商品规格
     *
     * @param list 商品规格列表
     * @return 商品 产品集合
     */
    public int bathDeleteListMallGoodsProduct(List<MallGoodsProduct> list);

    /**
     * 设置规格为0
     *
     * @param goodsId 商品ID
     * @return 商品 产品集合
     */
    public int setNotDefault(Long goodsId);

    /**
     * 设置一个默认规格
     *
     * @param goodsId 商品ID
     * @return 商品 产品集合
     */
    public int setDefault(Long goodsId);

    /**
     * 复制商品批量新增商品规格
     *
     * @param list 商品规格列表
     * @return 商品 产品集合
     */
    public int bathCopyInsertListMallGoodsProduct(List<MallGoodsProduct> list);

    /**
     * 复制商品批量删除商品规格
     *
     * @param list 商品规格列表
     * @return 商品 产品集合
     */
    public int bathCopyDeleteListMallGoodsProduct(List<MallGoodsGoods> list);

    /**
     * 查询复制商品copyId未设置的商品规格l列表
     *
     * @return 商品 产品集合
     */
    public List<MallGoodsProduct> selectMallGoodsProductListCopyIdIsNull();

    /**
     * 复制商品批量修改商品规格
     *
     * @param list 商品规格列表
     * @return 商品 产品集合
     */
    public int bathCopyUpdateListMallGoodsProduct(List<MallGoodsProduct> list);
}
